/*
 * pwm_rgb.h
 *
 * Created: 01.05.2012 18:07:17
 *  Author: Liz
 */ 


#ifndef PWM_RGB_H_
#define PWM_RGB_H_


#define DDR_DMUX DDRD
#define PORT_DMUX PORTD
#define DMUX0 PD1
#define DMUX1 PD2
#define DMUX2 PD3

#define PWM_R PB3
#define PWM_G PD4 //OC1B
//#define PWM_G PD5 //OC1A
#define PWM_B PD7

#define PORT_LED_BUTTONS PORTB
#define DDR_LED_BUTTONS DDRB
#define LED_BUTTON0 PB0
#define LED_BUTTON1 PB1
#define LED_BUTTON2 PB2


void init_pwm()
{
	
	//setare biti de iesire pt control DMUX
	set_bit(DDR_DMUX, DMUX0);
	set_bit(DDR_DMUX, DMUX1);
	set_bit(DDR_DMUX, DMUX2);
	
	
	// Configurare PWM
	
	
	TIMSK = 0;
	
	// TODO
	
	// Timer 0 - Red  (OC0)
	// 1. initializare pin
	// 2. Fast PWM, 1024 prescaler, non-inverting mode
	// 3. top
	
	DDRB |=(1<<PWM_R);
	//fast PWM
	TCCR0 |= (1<<WGM00) | (1<<WGM01);
	//1024 prescaler
	TCCR0 |= (1<<CS00) | (1<<CS02);
	//non-inverting mode
	TCCR0 |= (1<<COM00) | (1<<COM01);
	//top
	
	
	// Timer 1 B - Blue (OC1B)
	// 1. initializare pin
	// 2. modificare mod lucru
	// Phase and Frequency Correct PWM, 1024 prescaler, non-inverting mode
	// 3.top
	
	//What the... ??????????
	
	//iesirea mea de PWM este pe OC1B si in OCR1A tin TOP VALUE doar ?????
	
	DDRD |= (1<<PWM_G);
	TCCR1B |= (1<<WGM12);
	TCCR1A |= (1<<WGM10);
	//prescaler
	TCCR1B |= (1<<CS10);
	TCCR1B |= (1<<CS12);
	//non-inverting mode
	TCCR1A |= (1<<COM1B1);
	
		
	
	// Timer 2 - Green (OC2)
	// similar timer 0
	
	DDRD |= (1<<PWM_B);
	//fast PWM
	TCCR2 |= (1<<WGM20) | (1<<WGM21);
	//1024 prescaler
	TCCR2 |= (1<<CS20) | (1<<CS22);
	//non-inverting mode
	TCCR2 |= (1<<COM20) | (1<<COM21);
	//top
	
	
	// ce facea?!
		sei();
}

//mai intai light_up, apoi dmux_sel, apoi _delay_ms(10);

void light_up(unsigned char red, unsigned char green, unsigned char blue)
{
	// aprindeti ledurile la intensitatea dorita
	// hint: modificati valoarea TOP pentru PWM
	// Led RED - conectat pe pinul OC0
	// Led GREEN - conectat pe pinul OC2
	// Led BLUE - conectat pe pinul OC1B
	OCR0 = 255-red;
	//OCR1A = 255-blue;
	OCR1B = 255-green;
	OCR2 = 255-blue;	
}

void dmux_sel(unsigned char nr_led) {

	//pot face sau nu un clear inainte
//	clear_bit(PORT_DMUX, DMUX0);
//	clear_bit(PORT_DMUX, DMUX1);
//	clear_bit(PORT_DMUX, DMUX2);

	if(is_set(nr_led, 0)) set_bit(PORT_DMUX, DMUX0);
	else clear_bit(PORT_DMUX, DMUX0);
	if(is_set(nr_led, 1)) set_bit(PORT_DMUX, DMUX1);
	else clear_bit(PORT_DMUX, DMUX1);
	if(is_set(nr_led, 2)) set_bit(PORT_DMUX, DMUX2);
	else clear_bit(PORT_DMUX, DMUX2);
}

//nr led intre 0 si 7
#define light_up_LED(nr_led, red, green, blue) ({light_up((BYTE)red, (BYTE)green, (BYTE)blue); dmux_sel((BYTE)nr_led); _delay_ms(10);})

#endif /* PWM_RGB_H_ */