/*
 * spi_lcd.h
 *
 * Created: 01.05.2012 16:44:14
 *  Author: Liz
 */ 


#ifndef SPI_LCD_H_
#define SPI_LCD_H_

/*
 * spi_lcd.c
 *
 * Created: 01.05.2012 09:38:54
 *  Author: Liz
 */ 

#define RESET_CMD 0x01
#define SLEEP_OUT 0x11
#define BOOSTER_ON 0x03
#define DISPLAY_ON 0x29
#define NORMAL_DISPLAY_MODE 0x13
#define DISPLAY_INVERSION_ON 0x21
#define DATA_ORDER 0xBA
#define MEMORY_DATA_ACCESS_CONTROL 0x36
#define MODE_565 0x3A
#define CONTRAST 0x25
#define COLUMN_ADDRESS_SET 0x2A
#define PAGE_ADDRESS_SET 0x2B
#define MEMORY_WRITE 0x2C
#define READ_DISPLAY_STATUS 0x09


#define SPI_PORT PORTB
#define SPI_DDR DDRB
#define CS 4
#define CLK 7
#define DATA 5
#define RESET 6



/* USI control functions (Defined in usi.S, Platform dependent) */
void xmit_spi (BYTE);	/* Send a BYTE */
BYTE rcv_spi (void);	/* Send 0xFF and receive a BYTE */



// Port Controls  (Platform dependent)
#define SELECT()	SPI_PORT &= ~(1<<CS)     
#define DESELECT()	SPI_PORT |=  (1<<CS)  

/*
void init_spi (void)
{
	WORD tmr;

	DESELECT();												// set default CS pin	
	tmr = 2500;
	do
		asm volatile ("nop");
	while (--tmr);

	// set spi direction: MOSI and SCK as output, MISO as input
	SPI_DDR |= (1<<DATA) | (1<<CLK) | (1<<RESET) | (1<<CS);
    

	// Initialize SPI port, SPI enabled as master
	SPCR |= (1<<MSTR) | (1<<SPE);
    // SPI double speed settings
	SPSR |= (1<<SPI2X);	
	SPCR |= (1<<SPIE);
}

BYTE rcv_spi_m(void)
{
	//send a dummy BYTE (0xFF) in order to receive a BYTE from the slave
	SPDR = 0xFF;
	//wait for the reception to complete
	while (!(SPSR & (1 << SPIF)));		
	//return the read BYTE
	return SPDR;
}
void xmit_spi(BYTE dat)
{
	//send a BYTE to the slave
	SPDR = dat;	
	//wait for it to be serialized
	while (!(SPSR & (1 << SPIF)));	
}
	
void sendData(BYTE data) {

   set_bit(SPI_PORT, DATA);
   xmit_spi(data);
}

//send cmd
void sendCMD(BYTE data) {

   clear_bit(SPI_PORT, DATA);
   xmit_spi(data);
}

static
void release_spi (void)
{
	DESELECT();
	rcv_spi();
}


*/

void shiftBits(BYTE b) {

  clear_bit(SPI_PORT,CLK);
  if ((b&128)!=0) set_bit(SPI_PORT,DATA); else clear_bit(SPI_PORT,DATA);
  set_bit(SPI_PORT,CLK);

  clear_bit(SPI_PORT,CLK);
  if ((b&64)!=0) set_bit(SPI_PORT,DATA); else clear_bit(SPI_PORT,DATA);
  set_bit(SPI_PORT,CLK);

  clear_bit(SPI_PORT,CLK);
  if ((b&32)!=0) set_bit(SPI_PORT,DATA); else clear_bit(SPI_PORT,DATA);
  set_bit(SPI_PORT,CLK);

  clear_bit(SPI_PORT,CLK);
  if ((b&16)!=0) set_bit(SPI_PORT,DATA); else clear_bit(SPI_PORT,DATA);
  set_bit(SPI_PORT,CLK);

  clear_bit(SPI_PORT,CLK);
  if ((b&8)!=0) set_bit(SPI_PORT,DATA); else clear_bit(SPI_PORT,DATA);
  set_bit(SPI_PORT,CLK);

  clear_bit(SPI_PORT,CLK);
  if ((b&4)!=0) set_bit(SPI_PORT,DATA); else clear_bit(SPI_PORT,DATA);
  set_bit(SPI_PORT,CLK);

  clear_bit(SPI_PORT,CLK);
  if ((b&2)!=0) set_bit(SPI_PORT,DATA); else clear_bit(SPI_PORT,DATA);
  set_bit(SPI_PORT,CLK);

  clear_bit(SPI_PORT,CLK);
  if ((b&1)!=0) set_bit(SPI_PORT,DATA); else clear_bit(SPI_PORT,DATA);
  set_bit(SPI_PORT,CLK);

}


//send data
void sendData(BYTE data) {

  clear_bit(SPI_PORT,CLK);
  set_bit(SPI_PORT,DATA);                                                 //1 for param
  set_bit(SPI_PORT,CLK);

  shiftBits(data);
  
  //_delay_ms(100);
}

//send cmd
void sendCMD(BYTE data) {

  clear_bit(SPI_PORT,CLK);
  clear_bit(SPI_PORT,DATA);                                                 //1 for cmd
  set_bit(SPI_PORT,CLK);

  shiftBits(data);
  
 // _delay_ms(100);
}

void init_spi() {
	
	 SPI_DDR=(1<<DATA)|(1<<CLK)|(1<<CS)|(1<<RESET); //Port-Direction Setup
}


void init_lcd (void) {

  init_spi();

  SELECT();
  clear_bit(SPI_PORT, DATA);  
  set_bit(SPI_PORT, RESET);
  clear_bit(SPI_PORT, RESET);
  set_bit(SPI_PORT, RESET);  
  set_bit(SPI_PORT, DATA);

  _delay_ms(10);

  //Software Reset
  sendCMD(RESET_CMD);
 _delay_ms(10);
  //Sleep Out
  sendCMD(SLEEP_OUT);
 _delay_ms(10);
  //Booster ON
  sendCMD(BOOSTER_ON);

  _delay_ms(10);

  //Display On
  sendCMD(DISPLAY_ON);
 _delay_ms(10);
  //Normal display mode
  sendCMD( NORMAL_DISPLAY_MODE);
 _delay_ms(10);
  //Display inversion on
 //a sendCMD(DISPLAY_INVERSION_ON);

  //Data order
  sendCMD(DATA_ORDER);
 _delay_ms(10);
  //Memory data access control
  sendCMD(MEMORY_DATA_ACCESS_CONTROL);

// sendData(8|64);   //rgb + MirrorX
//  sendData(8|128);   //rgb + MirrorY
	sendData(8);
 _delay_ms(10);
//#ifdef MODE565
  sendCMD(MODE_565);
  sendData(5);   //16-Bit per Pixel
//#else
  //sendCMD(MODE_565);
  //sendData(3);   //12-Bit per Pixel (default)
//#endif
 _delay_ms(10);
  //sendCMD(CONTRAST);
  sendData(63);
}

void init_data_transm(BYTE xs, BYTE xe, BYTE ys, BYTE ye) {	
	
	  sendCMD(PAGE_ADDRESS_SET);
	
	 sendData(xs);
	  sendData(xe);
	  
	
	  sendCMD(COLUMN_ADDRESS_SET);
	  
	   sendData(ys);
	  sendData(ye);
	 sendCMD(MEMORY_WRITE);
}

BYTE n=0;
BYTE s1,s2;
BYTE r,g,b;

//converts a 3*8Bit-RGB-Pixel to the 2-BYTE-RGBRGB Format of the Display
void setPixel(BYTE r,BYTE g,BYTE b) {
//#ifdef MODE565
   sendData((r&248)|g>>5);
   sendData((g&7)<<5|b>>3);
//#else
/*
  if (n==0) {
    s1=(r & 240) | (g>>4);
    s2=(b & 240);
    n=1;
  } else {
    n=0;
    sendData(s1);
    sendData(s2|(r>>4));
    sendData((g&240) | (b>>4));
  }
#endif
*/
}


#define PORT_DIR_BUTTONS PORTC
#define DDR_DIR_BUTTONS DDRC
#define UP PC0
#define LEFT PC1
#define DOWN PC2
#define RIGHT PC3
#define RESET_BUTTON PC4
#define ENTER PC5


void init_dir_buttons() {
	
	//sunt input
	clear_bit(DDR_DIR_BUTTONS, UP);
	clear_bit(DDR_DIR_BUTTONS, DOWN);
	clear_bit(DDR_DIR_BUTTONS, LEFT);
	clear_bit(DDR_DIR_BUTTONS, RIGHT);
	clear_bit(DDR_DIR_BUTTONS, ENTER);
	clear_bit(DDR_DIR_BUTTONS, RESET_BUTTON);
	
	set_bit(PORT_DIR_BUTTONS, UP);
	set_bit(PORT_DIR_BUTTONS, DOWN);
	set_bit(PORT_DIR_BUTTONS, LEFT);
	set_bit(PORT_DIR_BUTTONS, RIGHT);
	set_bit(PORT_DIR_BUTTONS, ENTER);
	set_bit(PORT_DIR_BUTTONS, RESET_BUTTON);
	
	set_bit(PINC, UP);
	set_bit(PINC, DOWN);
	set_bit(PINC, LEFT);
	set_bit(PINC, RIGHT);
	set_bit(PINC, ENTER);
	set_bit(PINC, RESET_BUTTON);
	
}

#define draw_line(xs,ys,width,height,color) (draw_rectangle(xs,ys,width,height,0,color))

//pot sa mai scap de un parametru, sa transmit thickness 0 si asta sa insemne ca vreau fill
void draw_rectangle(BYTE ys, BYTE xs, BYTE height, BYTE width, BYTE thickness, struct rgb color) {
	
	if (thickness == 0) {
		
		init_data_transm(xs, xs+width-1, ys, ys+height-1);	
		int i;
		for (i = 0 ; i < width*height; i++)
			setPixel(color.r, color.g, color.b);			
	}
	else {
		
		//comanda adrese pe orizontala
	//	sendCMD(MEMORY_DATA_ACCESS_CONTROL);
	//	sendData(8);
		draw_line(xs, ys, width, thickness, color);
		draw_line(xs, ys+height-thickness, width, thickness, color);
		//comanda adrese pe verticala
	//	sendCMD(MEMORY_DATA_ACCESS_CONTROL);
	//	sendData(8|32);
		draw_line(xs, ys, thickness, height, color);
		draw_line(xs + width-thickness, ys, thickness, height, color);		
	//	sendCMD(MEMORY_DATA_ACCESS_CONTROL);
	//	sendData(8);
	}
}












const unsigned char FONT8x8[97][8] PROGMEM = {
{0x08,0x08,0x08,0x00,0x00,0x00,0x00,0x00}, // columns, rows, num_bytes_per_char
{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00}, // space 0x20
{0x30,0x78,0x78,0x30,0x30,0x00,0x30,0x00}, // !
{0x6C,0x6C,0x6C,0x00,0x00,0x00,0x00,0x00}, // "
{0x6C,0x6C,0xFE,0x6C,0xFE,0x6C,0x6C,0x00}, // #
{0x18,0x3E,0x60,0x3C,0x06,0x7C,0x18,0x00}, // $
{0x00,0x63,0x66,0x0C,0x18,0x33,0x63,0x00}, // %
{0x1C,0x36,0x1C,0x3B,0x6E,0x66,0x3B,0x00}, // &
{0x30,0x30,0x60,0x00,0x00,0x00,0x00,0x00}, // '
{0x0C,0x18,0x30,0x30,0x30,0x18,0x0C,0x00}, // (
{0x30,0x18,0x0C,0x0C,0x0C,0x18,0x30,0x00}, // )
{0x00,0x66,0x3C,0xFF,0x3C,0x66,0x00,0x00}, // *
{0x00,0x30,0x30,0xFC,0x30,0x30,0x00,0x00}, // +
{0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x30}, // ,
{0x00,0x00,0x00,0x7E,0x00,0x00,0x00,0x00}, // -
{0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x00}, // .
{0x03,0x06,0x0C,0x18,0x30,0x60,0x40,0x00}, // / (forward slash)
{0x3E,0x63,0x63,0x6B,0x63,0x63,0x3E,0x00}, // 0 0x30
{0x18,0x38,0x58,0x18,0x18,0x18,0x7E,0x00}, // 1
{0x3C,0x66,0x06,0x1C,0x30,0x66,0x7E,0x00}, // 2
{0x3C,0x66,0x06,0x1C,0x06,0x66,0x3C,0x00}, // 3
{0x0E,0x1E,0x36,0x66,0x7F,0x06,0x0F,0x00}, // 4
{0x7E,0x60,0x7C,0x06,0x06,0x66,0x3C,0x00}, // 5
{0x1C,0x30,0x60,0x7C,0x66,0x66,0x3C,0x00}, // 6
{0x7E,0x66,0x06,0x0C,0x18,0x18,0x18,0x00}, // 7
{0x3C,0x66,0x66,0x3C,0x66,0x66,0x3C,0x00}, // 8
{0x3C,0x66,0x66,0x3E,0x06,0x0C,0x38,0x00}, // 9
{0x00,0x18,0x18,0x00,0x00,0x18,0x18,0x00}, // :
{0x00,0x18,0x18,0x00,0x00,0x18,0x18,0x30}, // ;
{0x0C,0x18,0x30,0x60,0x30,0x18,0x0C,0x00}, // <
{0x00,0x00,0x7E,0x00,0x00,0x7E,0x00,0x00}, // =
{0x30,0x18,0x0C,0x06,0x0C,0x18,0x30,0x00}, // >
{0x3C,0x66,0x06,0x0C,0x18,0x00,0x18,0x00}, // ?
{0x3E,0x63,0x6F,0x69,0x6F,0x60,0x3E,0x00}, // @ 0x40
{0x18,0x3C,0x66,0x66,0x7E,0x66,0x66,0x00}, // A
{0x7E,0x33,0x33,0x3E,0x33,0x33,0x7E,0x00}, // B
{0x1E,0x33,0x60,0x60,0x60,0x33,0x1E,0x00}, // C
{0x7C,0x36,0x33,0x33,0x33,0x36,0x7C,0x00}, // D
{0x7F,0x31,0x34,0x3C,0x34,0x31,0x7F,0x00}, // E
{0x7F,0x31,0x34,0x3C,0x34,0x30,0x78,0x00}, // F
{0x1E,0x33,0x60,0x60,0x67,0x33,0x1F,0x00}, // G
{0x66,0x66,0x66,0x7E,0x66,0x66,0x66,0x00}, // H
{0x3C,0x18,0x18,0x18,0x18,0x18,0x3C,0x00}, // I
{0x0F,0x06,0x06,0x06,0x66,0x66,0x3C,0x00}, // J
{0x73,0x33,0x36,0x3C,0x36,0x33,0x73,0x00}, // K
{0x78,0x30,0x30,0x30,0x31,0x33,0x7F,0x00}, // L
{0x63,0x77,0x7F,0x7F,0x6B,0x63,0x63,0x00}, // M
{0x63,0x73,0x7B,0x6F,0x67,0x63,0x63,0x00}, // N
{0x3E,0x63,0x63,0x63,0x63,0x63,0x3E,0x00}, // O
{0x7E,0x33,0x33,0x3E,0x30,0x30,0x78,0x00}, // P 0x50
{0x3C,0x66,0x66,0x66,0x6E,0x3C,0x0E,0x00}, // Q
{0x7E,0x33,0x33,0x3E,0x36,0x33,0x73,0x00}, // R
{0x3C,0x66,0x30,0x18,0x0C,0x66,0x3C,0x00}, // S
{0x7E,0x5A,0x18,0x18,0x18,0x18,0x3C,0x00}, // T
{0x66,0x66,0x66,0x66,0x66,0x66,0x7E,0x00}, // U
{0x66,0x66,0x66,0x66,0x66,0x3C,0x18,0x00}, // V
{0x63,0x63,0x63,0x6B,0x7F,0x77,0x63,0x00}, // W
{0x63,0x63,0x36,0x1C,0x1C,0x36,0x63,0x00}, // X
{0x66,0x66,0x66,0x3C,0x18,0x18,0x3C,0x00}, // Y
{0x7F,0x63,0x46,0x0C,0x19,0x33,0x7F,0x00}, // Z
{0x3C,0x30,0x30,0x30,0x30,0x30,0x3C,0x00}, // [
{0x60,0x30,0x18,0x0C,0x06,0x03,0x01,0x00}, // \ (back slash)
{0x3C,0x0C,0x0C,0x0C,0x0C,0x0C,0x3C,0x00}, // ]
{0x08,0x1C,0x36,0x63,0x00,0x00,0x00,0x00}, // ^
{0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF}, // _
{0x18,0x18,0x0C,0x00,0x00,0x00,0x00,0x00}, // ` 0x60
{0x00,0x00,0x3C,0x06,0x3E,0x66,0x3B,0x00}, // a
{0x70,0x30,0x3E,0x33,0x33,0x33,0x6E,0x00}, // b
{0x00,0x00,0x3C,0x66,0x60,0x66,0x3C,0x00}, // c
{0x0E,0x06,0x3E,0x66,0x66,0x66,0x3B,0x00}, // d
{0x00,0x00,0x3C,0x66,0x7E,0x60,0x3C,0x00}, // e
{0x1C,0x36,0x30,0x78,0x30,0x30,0x78,0x00}, // f
{0x00,0x00,0x3B,0x66,0x66,0x3E,0x06,0x7C}, // g
{0x70,0x30,0x36,0x3B,0x33,0x33,0x73,0x00}, // h
{0x18,0x00,0x38,0x18,0x18,0x18,0x3C,0x00}, // i
{0x06,0x00,0x06,0x06,0x06,0x66,0x66,0x3C}, // j
{0x70,0x30,0x33,0x36,0x3C,0x36,0x73,0x00}, // k
{0x38,0x18,0x18,0x18,0x18,0x18,0x3C,0x00}, // l
{0x00,0x00,0x66,0x7F,0x7F,0x6B,0x63,0x00}, // m
{0x00,0x00,0x7C,0x66,0x66,0x66,0x66,0x00}, // n
{0x00,0x00,0x3C,0x66,0x66,0x66,0x3C,0x00}, // o
{0x00,0x00,0x6E,0x33,0x33,0x3E,0x30,0x78}, // p 0x70
{0x00,0x00,0x3B,0x66,0x66,0x3E,0x06,0x0F}, // q
{0x00,0x00,0x6E,0x3B,0x33,0x30,0x78,0x00}, // r
{0x00,0x00,0x3E,0x60,0x3C,0x06,0x7C,0x00}, // s
{0x08,0x18,0x3E,0x18,0x18,0x1A,0x0C,0x00}, // t
{0x00,0x00,0x66,0x66,0x66,0x66,0x3B,0x00}, // u
{0x00,0x00,0x66,0x66,0x66,0x3C,0x18,0x00}, // v
{0x00,0x00,0x63,0x6B,0x7F,0x7F,0x36,0x00}, // w
{0x00,0x00,0x63,0x36,0x1C,0x36,0x63,0x00}, // x
{0x00,0x00,0x66,0x66,0x66,0x3E,0x06,0x7C}, // y
{0x00,0x00,0x7E,0x4C,0x18,0x32,0x7E,0x00}, // z
{0x0E,0x18,0x18,0x70,0x18,0x18,0x0E,0x00}, // {
{0x0C,0x0C,0x0C,0x00,0x0C,0x0C,0x0C,0x00}, // |
{0x70,0x18,0x18,0x0E,0x18,0x18,0x70,0x00}, // }
{0x3B,0x6E,0x00,0x00,0x00,0x00,0x00,0x00}, // ~
{0x1C,0x36,0x36,0x1C,0x00,0x00,0x00,0x00}}; // DEL


enum font_size{MEDIUM_FONT = 0, SMALL_FONT};



void LCDPutChar(char c, int x, int y, int size, struct rgb fColor, struct rgb bColor) {

	
	int i,j;
	unsigned int nCols;
	unsigned int nRows;
	unsigned int nBytes;
	unsigned char PixelRow;
	unsigned char Mask;
	struct rgb pixel;
	unsigned char *pFont;
	unsigned char pChar[8];
	unsigned char FontRow[8];
	memcpy_P(FontRow, &FONT8x8[0][0], 8);
	// get pointer to the beginning of the selected font table
	pFont = (unsigned char *)&FontRow[0];
	// get the nColumns, nRows and nBytes
	nCols = *pFont;
	nRows = *(pFont + 1);
	nBytes = *(pFont + 2);
	// get pointer to the last byte of the desired character
	//pChar = pFont + (nBytes * (c - 0x1F)) ;
	memcpy_P(pChar, &FONT8x8[0][0] + (nBytes*(c-0x1F)), 8);	
	
//	init_data_transm(x, x+nRows-1, y, y+nCols-1);	
	
	// Row address set (command 0x2B)
	sendCMD(PAGE_ADDRESS_SET);
	sendData(y);
	sendData(y + nCols - 1);	
	// Column address set (command 0x2A)
	sendCMD(COLUMN_ADDRESS_SET);
	sendData(x);
	sendData(x + nRows - 1);
	
	
	// WRITE MEMORY
	sendCMD(MEMORY_WRITE);	
  
	// loop on each row, working backwards from the bottom to the top
	for (i = 0; i < nRows; i++) {
		// copy pixel row from font table and then decrement row
		PixelRow = pChar[i];
	
		// loop on each pixel in the row (left to right)
		Mask = 0x80;
		
		for (j = 0; j < nCols; j ++) {
			// if pixel bit set, use foreground color; else use the background color
			// now get the pixel color for two successive pixels
			if ((PixelRow & Mask) == 0)
			pixel = bColor;
			else
			pixel = fColor;
			Mask = Mask >> 1;
			// use this information to output three data bytes
			setPixel(pixel.r, pixel.g, pixel.b);
		}
	}
	
	sendCMD(0x00);	
}

void LCDPutStr(char *pString, int x, int y, int Size, struct rgb fColor, struct rgb bColor) {
// loop until null-terminator is seen
	while (*pString != 0x00) {
		// draw the character
		LCDPutChar(*pString++, x, y, Size, fColor, bColor);
		// advance the y position
		if (Size == SMALL_FONT)
		x = x + 6;
		else if (Size == MEDIUM_FONT)
		x = x + 8;
		else
		x = x + 8;
		// bail out if y exceeds 131
		if (x > 131) break;
	}
}











#endif /* SPI_LCD_H_ */